﻿Type=Activity
Version=3.78
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim phon As Phone
	Dim SourceImageRect, TouchImageViewRect As Rect
	
	Private streamer As AudioStreamer
	Private buffers As List
	Private timer1 As Timer
	Private recordingStart As Long
	Private output As OutputStream
	Private recording As Boolean
	Private mBitRate As Int = 16
	Private mSampleRate As Int = 22050
	Private mMono As Boolean = True
	Private mFileName As String = "1.wav"
	Private mp As MediaPlayer
	
	
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim TouchImageView1 As TouchImageView
	Dim pnl As Panel	
	' Dim rx,ry As Float
	Dim bcount As Int
	Dim blist As List 
	Dim tagmodus As Boolean
	  
	Private bpoints As Button
	Private btag As Button
	Dim men As AHPopupMenu
	Private Brecstop As Button
	Dim mainmenu As AHPopupMenu
	Private Bmainmenu As Button
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("touch")
	bcount=0
	phon.setscreenorientation (0)
	
	TouchImageView1.Initialize("TouchImageView1")
	Activity.AddView(TouchImageView1, 0, 0, 100%x, 100%y)
	
	' TouchImageView1.MinScale=0.25			'	default is 0.5
	' TouchImageView1.MaxScale=2				'	default is 1.5
	' TouchImageView1.TranslatePadding=128dip	'	default is 64dip
	
	TouchImageView1.Gravity=Gravity.FILL
	' TouchImageView1.SetBackgroundImage(LoadBitmap(File.DirAssets, "b4a_logo.png"))
	
	Dim Bitmap1 As Bitmap
	
	Bitmap1.Initialize(Main.outdir, Main.thepic)
	' Bitmap1.Initialize(File.DirAssets,"Rose2.jpg" )
	TouchImageView1.SetBitmap(Bitmap1)
	
	If FirstTime Then
		'	Rect parameters are: left, top, right, bottom
		SourceImageRect.Initialize(0, 0, Bitmap1.Width, Bitmap1.Height)
		TouchImageViewRect.Initialize(0, 0, TouchImageView1.Width, TouchImageView1.Height)
		
		streamer.Initialize("streamer", mSampleRate, mMono, mBitRate, streamer.VOLUME_MUSIC)
		buffers.Initialize
		timer1.Initialize("timer1", 1000)
		mp.Initialize2("mp")
		
	End If
	 
	
	'	if the scaling process scales the image to less than the current MinScale or more than the current MaxScale then MinScale or MaxScale will be adjusted
	TouchImageView1.ScaleSrcRectToDestRect(SourceImageRect, TouchImageViewRect, "START")	'	make string a static constant in library
	
	pnl.Initialize ("pnl")
	Activity.AddView(pnl, 0, 0, 100%x, 80%y)
	pnl.Color = Colors.ARGB(0, 0, 0, 0)
	
	blist.Initialize
	' bpoints.Initialize ("bpoints")
	' btag.Initialize ("btag")
	Dim wi,he As Int
	wi=120dip
	he=40dip
	bpoints.Color=Main.btnpressedcolor
	bpoints.TextColor=Main.btntxtcolor
	btag.Color=Main.btncolor
	btag.TextColor=Main.btntxtcolor
	' l1=pnl.Width + 10dip
	' l2=pnl.Width + 10dip
	' Dim i As Int
	' i=pnl.Height-(2 * he)
	' i=i / 3
	' t1=i
	' Dim t2 As Int
	' t2=i+i+he
	bpoints.Text="Hinzufügen"
	btag.Text="Bearbeiten"
	' Activity.AddView (bpoints,l1,t1,wi,he)
	' Activity.AddView (btag,l2,t2,wi,he)
	bpoints.Left=TouchImageView1.Width-wi-20dip
	' bpoints.Top=i
	bpoints.Width=wi
	bpoints.Height=he
	btag.Left=TouchImageView1.Width-wi-20dip
	' btag.Top=t2
	btag.Width=wi
	btag.Height=he
	tagmodus=False
	btag.BringToFront
	bpoints.BringToFront
	men.Initialize("AC")
	Dim ai As AHActionItem
	ai.Initialize(1, "Voice Tag",Null)
	men.AddActionItem(ai)
	
	Brecstop.Visible=False
	Brecstop.Color=Main.btncolor
	Brecstop.TextColor=Main.btntxtcolor
	Brecstop.width=wi
	Brecstop.left=btag.Left
	Brecstop.top=100%y-Brecstop.height
	
	Bmainmenu.Color=Main.btncolor
	Bmainmenu.TextColor=Main.btntxtcolor
	Bmainmenu.Left=btag.Left
	Bmainmenu.Width=wi
	Bmainmenu.Height=Brecstop.Height
	Bmainmenu.Top=100%y-Bmainmenu.Height
	
	Bmainmenu.Text="Menü"
	
	bpoints.Top=0
	btag.Top=he*2
	
	Bmainmenu.BringToFront
	' Msgbox (Brecstop.Left,Brecstop.Top)
	mainmenu.Initialize("Mainmenu")
	Dim aai As AHActionItem
	aai.Initialize(1, "Kamera",Null)
	mainmenu.AddActionItem(aai)
	Dim aai2 As AHActionItem
	aai2.Initialize(2, "Mails mir",Null)
	mainmenu.AddActionItem(aai2)
	
	mainmenu.AnimStyle=men.anim_grow_from_right
End Sub

Sub Activity_Resume
	Log ("Resume")
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	TouchImageViewRect=TouchImageView1.GetDestRect
	If UserClosed Then Brecstop_Click
End Sub



'Sub TouchImageView1_Click(X As Int, y As Int)
'	Log("Click X="&X&", Y="&y)
'	Dim b As Button
'	b.initialize ("touchbtn")
'	bcount=bcount+1
'	b.Tag=bcount
'	b.Text=bcount
'	b.color=Colors.red
'	Dim x2,y2 As Int
'	Dim r As Rect
'	r=TouchImageView1.GetDestRect
'	x2=r.Left+(TouchImageView1.ScaleX*X)
'	y2=r.Top+(TouchImageView1.Scaley*y)
'	pnl.addview (b,X-25,y-25,50,50)
'
'	'	zoom the image in by 5% on the clicked point
'	'	the new scale factor will be the previous scale factor * 1.05
'	
'	' TouchImageView1.PreScale(1.05, X, y)
'End Sub
	
Sub TouchImageView1_LongClick(X As Int, Y As Int)
	Log("LongClick X="&X&", Y="&Y)
	
	'	set the zoom/scale to 100%
	'	in this demo ScaleX and ScaleY will always be equal
	' TouchImageView1.PreScale(1/TouchImageView1.ScaleX, X, Y)
	
End Sub

Sub touchbtn_click
	If tagmodus=False Then Return
	Dim Send As Button
    Send=Sender
	mFileName=Main.photoaid & "_" & Send.Tag & ".wav"
	' Activity.Title=Send.Text
	' ToastMessageShow (Send.tag,True)
	men.Show(Sender)
End Sub

Sub pnl_Touch (Action As Int, X As Float, Y As Float)
 	Log (Action & ": " & X & " " & Y)
	If tagmodus=True Then Return
	If Action = Activity.ACTION_down Then
		' pnl.RemoveAllViews
		
		If recording Then
			Brecstop_Click
		End If
		Dim b As Button
		b.initialize ("touchbtn")
		bcount=bcount+1
		b.tag=bcount
		b.Text=bcount
		b.color=Colors.red
		
		' Dim px,py As Float
		' px=X*TouchImageView1.ScaleX
		' py=Y*TouchImageView1.Scaley
' 		Log ("px=" & px & ",py=" & py)
'		Dim fx,fy As Float
'		Dim r As Rect
'		r=TouchImageView1.GetDestRect
'		fx=px + r.Left
'		fy=py + r.Top
'		Log ("fx=" & fx & ",fy=" & fy)
		' x2=r.Left+(TouchImageView1.ScaleX*X)
		' y2=r.Top+(TouchImageView1.Scaley*Y)
		
		' simma im rect?
		Dim r As Rect
		r=TouchImageView1.GetDestRect
		Dim px,py As Float
		Dim imrect As Boolean
		imrect=True
		px=(X  - r.Left) / TouchImageView1.ScaleX
		py=(Y -r.Top) / TouchImageView1.Scaley
		' Msgbox ("x=" & X & " y=" & Y,"px=" & px & ",py=" & py)
		If X < r.Left Then imrect=False
		If Y < r.top  Then imrect=False
		If X > r.right*1.2 Then imrect=False
		If Y > r.bottom*1.2 Then imrect=False
		If imrect Then 
			pnl.addview (b,X-25,Y-25,50,50)
			' Msgbox (pnl.Width,pnl.Height)
			' Msgbox (X,Y)
			Dim amap As Map
			amap.Initialize
			amap.put ("x",px)
			amap.put ("y",py)
			blist.Add (amap)
			Dim s As String
			Dim rx,ry As Float
			' rx=X / pnl.Width
			' ry=Y / pnl.height
			rx=X / (r.Right-r.Left)
			ry=Y / (r.bottom-r.Top)
			
			s = "insert into tags values (NULL," & Main.photoaid & "," & bcount & "," & rx & "," & ry & ")"
			
			Main.SQL1.execnonquery (s)
			
			mFileName=Main.photoaid & "_" & bcount & ".wav"
			buffers.Clear
			output = StartWaveFile(Main.outdir, mFileName, mSampleRate, mMono, mBitRate)
			recording = True
			streamer.StartRecording
			recordingStart = DateTime.Now
			timer1.Enabled = True
			Brecstop.Visible=True
			Brecstop.BringToFront
			Timer1_Tick
		End If
	End If
	If Action = Activity.ACTION_up Then
		pnl.RemoveAllViews
		Dim r As Rect
		r=TouchImageView1.GetDestRect
		Dim iz As Int
		For iz=0 To blist.size-1
			Dim amap As Map
			amap=blist.Get (iz)
			Dim px,py As Float
			px=amap.Get("x")*TouchImageView1.ScaleX + r.Left
			py=amap.get("y")*TouchImageView1.Scaley + r.Top
			Dim b As Button
			b.initialize ("touchbtn")
			bcount=iz+1
			b.tag=bcount
			b.Text=bcount
			b.color=Colors.red
			pnl.addview (b,px-25,py-25,50,50)
			
			
		Next
	End If
	' TouchImageView1_Click (X,Y)
End Sub
	

Sub btag_Click
	tagmodus=True
	bpoints.Color=Main.btncolor
	btag.Color=Main.btnpressedcolor
	
End Sub
Sub bpoints_Click
	tagmodus=False
	bpoints.Color=Main.btnpressedcolor
	btag.Color=Main.btncolor
End Sub

Sub StartWaveFile(Dir As String, FileName As String, SampleRate As Int, Mono As Boolean _
		, BitsPerSample As Int) As OutputStream
	File.Delete(Dir, FileName)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir, FileName, False, True)
	raf.WriteBytes("RIFF".GetBytes("ASCII"), 0, 4, raf.CurrentPosition)
	raf.CurrentPosition = 8 'skip 4 bytes for the size
	raf.WriteBytes("WAVE".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteBytes("fmt ".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(16, raf.CurrentPosition)
	raf.WriteShort(1, raf.CurrentPosition)
	Dim numberOfChannels As Int
	If Mono Then numberOfChannels = 1 Else numberOfChannels = 2
	raf.WriteShort(numberOfChannels, raf.CurrentPosition)
	raf.WriteInt(SampleRate, raf.CurrentPosition)
	raf.WriteInt(SampleRate * numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(BitsPerSample, raf.CurrentPosition)
	raf.WriteBytes("data".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(0, raf.CurrentPosition)
	raf.Close
	Return File.OpenOutput(Dir, FileName, True)
End Sub

Sub CloseWaveFile(Dir As String, FileName As String)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir, FileName, False, True)
	raf.WriteInt(raf.Size - 8, 4)
	raf.WriteInt(raf.Size - 44, 40)
	raf.Close
End Sub

Sub streamer_RecordBuffer (Buffer() As Byte)
	If recording Then output.WriteBytes(Buffer, 0, Buffer.Length)
	'the above check is required as the last message will arrive after we call StopRecording.
End Sub

Sub Timer1_Tick
	Brecstop.Text = Round((DateTime.Now - recordingStart) / DateTime.TicksPerSecond) & " sec" & CRLF & "Stop"
End Sub

Sub AC_Click (Position As Int, ActionItemID As Int)
	Dim Action As AHActionItem
	Action = men.getActionItem(Position)
	' ToastMessageShow(Action.Title & " pressed", False)
	Select Action.Title
		Case "Voice Tag"
			' StartActivity ("Kamera")
			buffers.Clear
			output = StartWaveFile(Main.outdir, mFileName, mSampleRate, mMono, mBitRate)
			recording = True
			streamer.StartRecording
			recordingStart = DateTime.Now
			timer1.Enabled = True
			Brecstop.Visible=True
			Brecstop.BringToFront
			Timer1_Tick
			
		
	End Select
	
End Sub


Sub Brecstop_Click
	streamer.StopRecording
	recording = False
	output.Close
	CloseWaveFile(File.DirRootExternal, mFileName)
	timer1.Enabled = False
	' btnPlay.Enabled = True
	' Label1.Text = ""
	' SendMail ("office@grafsoft.at","body","voice",File.Combine (File.DirRootExternal, mFileName))
	' Msgbox (Brecstop.Left,Brecstop.Top)
	Brecstop.Visible=False
End Sub

Sub SendMail(SendTo As String, SendBody As String, SendSub As String, SendAtt As String)
   Dim ei As Email
   ei.To.Add(SendTo)
   ei.Body = SendBody
   ei.Subject = SendSub
   If SendAtt <> "" Then
      ei.Attachments.Add(SendAtt)
   End If   
   StartActivity(ei.GetIntent)
End Sub

Sub mainmenu_Click (Position As Int, ActionItemID As Int)
	Dim Action As AHActionItem
	Action = mainmenu.getActionItem(Position)
	' ToastMessageShow(Action.Title & " pressed", False)
	Select Action.Title
		Case "Kamera"
			Activity.Finish
			' StartActivity ("Galerie")	
		Case "Mails mir"
			StartActivity (Paint)	
			' dann weiter mit myzip
	End Select
	
End Sub



Sub Bmainmenu_Click
	mainmenu.Show(Sender)
 End Sub

' http://maps.google.com/maps?q=39.211374,-82.978277+(My+Point)&z=14&ll=39.211374,-82.978277