﻿Type=Activity
Version=3.78
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private frontCamera As Boolean = False
	Dim phon As Phone
	Dim gps1 As GPS
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private Panel1 As Panel
	Private camEx As CameraExClass
	Private Btnclick As Button
	Private Btnfocus As Button
	Dim lati,longi As Double
	Private Btngps As Button
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	phon.setscreenorientation (0)
	Activity.LoadLayout("Kamera")
	Panel1.Left=0
	Panel1.Top=0
	Panel1.Width=75%x
	Panel1.Height=100%y
	Btnclick.Color=Main.btncolor
	Btnclick.TextColor=Main.btntxtcolor
	Btnfocus.Color=Main.btncolor
	Btnfocus.TextColor=Main.btntxtcolor
	Btnclick.Text="Klick"
	Btnfocus.Text="Focus und Click"
	Btnclick.Left=Panel1.Width + 10dip
	Btnfocus.Left=Panel1.Width + 10dip
	Btnclick.Top=0%y
	Btnfocus.Top=30%y
	Btnclick.Width=100%x - Panel1.Width - 20dip
	Btnfocus.Width=100%x - Panel1.Width - 20dip
	Btngps.Color=Main.btncolor
	Btngps.TextColor=Main.btntxtcolor
	Btngps.Width=100%x - Panel1.Width - 20dip
	Btngps.Top=100%y-Btngps.Height
	Btngps.Left=Panel1.Width + 10dip
	Btngps.Text="Warte auf" & CRLF & "GPS-Signal"
	' phon.setscreenorientation (0)
	
	
	If FirstTime Then
		gps1.Initialize("GPS")
	End If
	lati=0
	longi=0
	
End Sub
 	
Sub Activity_Resume
	InitializeCamera
	If gps1.GPSEnabled = False Then
        ToastMessageShow("Bitte GPS einschalten.", True)
        StartActivity(gps1.LocationSettingsIntent) 'Will open the relevant settings screen.
    Else
        gps1.Start(0, 0) 'Listen to GPS with no filters.
    End If
End Sub

Private Sub InitializeCamera
	camEx.Initialize(Panel1, frontCamera, Me, "Camera1")
	frontCamera = camEx.Front
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	camEx.Release	
	gps1.Stop
End Sub

Sub GPS_locationchanged (Location1 As Location)
	lati=Location1.latitude
	longi=Location1.Longitude
	Btngps.Visible=False
	
End Sub


Sub Camera1_Ready (Success As Boolean)
	If Success Then
		camEx.SetJpegQuality(100)
		camEx.CommitParameters
		camEx.StartPreview
		Log(camEx.GetPreviewSize)
	Else
		ToastMessageShow("Die Kamera funktioniert nicht.", True)
	End If
End Sub


Sub Btnfocus_Click
	Try
		camEx.focusandTakePicture
	Catch
		Log (LastException.Message)
	End Try
End Sub
Sub Btnclick_Click
	Try
		camEx.TakePicture
	Catch
		Log (LastException.Message)
	End Try
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	' Msgbox (lati,longi)
	
	Dim t As String
	Dim found As Boolean = True
	Dim iz As Int
	iz=0
	Do While found=True
		iz=iz+1
		t=iz & ".jpg"
		If File.Exists (Main.outdir,t)=False Then 
			found=False
		End If
	Loop
	Main.photonumber=iz
	Dim filename As String 
	filename=t
	Dim dir As String = Main.outdir
	Main.thepic=filename
	camEx.SavePictureToFile(Data, dir, filename)
	' msgbox (camex.GetPictureSize,"")
	camEx.StartPreview 'restart preview
	
	'send a broadcast intent to the media scanner to force it to scan the saved file.
	Dim Phone As Phone
	Dim i As Intent
	i.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
		"file://" & File.Combine(dir, filename))
	Phone.SendBroadcastIntent(i)
	' ToastMessageShow("Picture saved." & CRLF  & "File size: " & File.Size(dir, filename), True)
	ToastMessageShow("Gespeichert.",True)
	Dim s As String
	s = "insert into photos values (NULL," & Main.projectnumber & "," & iz & "," & lati & "," & longi & ")"
	Main.SQL1.execnonquery (s)
	Main.photoaid= Main.SQL1.ExecQuerySingleResult("SELECT MAX(AID) FROM photos")
	StartActivity ("Touch")
End Sub

Sub Btngps_Click
	
End Sub